Index: /trunk/tests/phpunit/testcases/core/nav/bpCoreMaybeHookNewSubnavScreenFunction.php
===================================================================
--- /trunk/tests/phpunit/testcases/core/nav/bpCoreMaybeHookNewSubnavScreenFunction.php	(revision 10744)
+++ /trunk/tests/phpunit/testcases/core/nav/bpCoreMaybeHookNewSubnavScreenFunction.php	(revision 10745)
@@ -83,9 +83,11 @@
 		$old_default_component = buddypress()->default_component;
 		buddypress()->default_component = 'foo';
-		buddypress()->bp_nav = array(
-			'foo' => array(
-				'show_for_displayed_user' => true,
-			),
-		);
+
+		bp_core_new_nav_item( array(
+			'slug' => 'foo',
+			'name' => 'Foo',
+			'screen_function' => 'foo',
+			'default_subnav_item' => 'bar',
+		) );
 
 		$subnav_item = array(
@@ -95,6 +97,4 @@
 		// Just test relevant info
 		$found = bp_core_maybe_hook_new_subnav_screen_function( $subnav_item );
-		$this->assertSame( 'failure', $found['status'] );
-		$this->assertSame( bp_core_get_user_domain( $u2 ), $found['redirect_args']['root'] );
 
 		// Clean up
@@ -102,4 +102,7 @@
 		buddypress()->default_component = $old_default_component;
 		buddypress()->bp_nav = $old_bp_nav;
+
+		$this->assertSame( 'failure', $found['status'] );
+		$this->assertSame( bp_core_get_user_domain( $u2 ), $found['redirect_args']['root'] );
 	}
 
@@ -115,9 +118,12 @@
 		$old_default_component = buddypress()->default_component;
 		buddypress()->default_component = 'foo';
-		buddypress()->bp_nav = array(
-			'foo' => array(
-				'show_for_displayed_user' => false,
-			),
-		);
+
+		bp_core_new_nav_item( array(
+			'slug' => 'foo',
+			'name' => 'Foo',
+			'screen_function' => 'foo',
+			'default_subnav_item' => 'bar',
+			'show_for_displayed_user' => false,
+		) );
 
 		$subnav_item = array(
@@ -127,6 +133,4 @@
 		// Just test relevant info
 		$found = bp_core_maybe_hook_new_subnav_screen_function( $subnav_item );
-		$this->assertSame( 'failure', $found['status'] );
-		$this->assertSame( bp_core_get_user_domain( $u2 ) . bp_get_activity_slug() . '/', $found['redirect_args']['root'] );
 
 		// Clean up
@@ -134,4 +138,7 @@
 		buddypress()->default_component = $old_default_component;
 		buddypress()->bp_nav = $old_bp_nav;
+
+		$this->assertSame( 'failure', $found['status'] );
+		$this->assertSame( bp_core_get_user_domain( $u2 ) . bp_get_activity_slug() . '/', $found['redirect_args']['root'] );
 	}
 
Index: /trunk/tests/phpunit/testcases/core/nav/bpCoreNewNavItem.php
===================================================================
--- /trunk/tests/phpunit/testcases/core/nav/bpCoreNewNavItem.php	(revision 10744)
+++ /trunk/tests/phpunit/testcases/core/nav/bpCoreNewNavItem.php	(revision 10745)
@@ -6,4 +6,7 @@
 class BP_Tests_Core_Nav_BpCoreNewNavItem extends BP_UnitTestCase {
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_user_nav() {
 		$bp_nav = buddypress()->bp_nav;
@@ -34,11 +37,16 @@
 		);
 
-		$this->assertSame( buddypress()->bp_nav['foo'], $expected );
-
-		// Clean up
-		buddypress()->bp_nav = $bp_nav;
-		$this->set_current_user( $old_current_user );
-	}
-
+		foreach ( $expected as $k => $v ) {
+			$this->assertEquals( $v, buddypress()->bp_nav['foo'][ $k ] );
+		}
+
+		// Clean up
+		buddypress()->bp_nav = $bp_nav;
+		$this->set_current_user( $old_current_user );
+	}
+
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_group_nav() {
 		$bp_nav = buddypress()->bp_nav;
@@ -90,4 +98,7 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_css_id_should_fall_back_on_slug() {
 		$args = array(
@@ -100,4 +111,7 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_css_id_should_be_respected() {
 		$args = array(
@@ -125,4 +139,7 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_existence_of_access_protected_user_nav() {
 		$bp_nav = buddypress()->bp_nav;
@@ -146,11 +163,16 @@
 		);
 
-		$this->assertSame( buddypress()->bp_nav['settings'], $expected );
-
-		// Clean up
-		buddypress()->bp_nav = $bp_nav;
-		$this->set_current_user( $old_current_user );
-	}
-
+		foreach ( $expected as $k => $v ) {
+			$this->assertEquals( $v, buddypress()->bp_nav['settings'][ $k ] );
+		}
+
+		// Clean up
+		buddypress()->bp_nav = $bp_nav;
+		$this->set_current_user( $old_current_user );
+	}
+
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_creation_of_access_protected_user_nav() {
 		// The nav item must be added to bp_nav, even if the current user
@@ -185,5 +207,7 @@
 		);
 
-		$this->assertSame( buddypress()->bp_nav['woof'], $expected );
+		foreach ( $expected as $k => $v ) {
+			$this->assertEquals( $v, buddypress()->bp_nav['woof'][ $k ] );
+		}
 
 		// Clean up
Index: /trunk/tests/phpunit/testcases/core/nav/bpCoreNewSubnavItem.php
===================================================================
--- /trunk/tests/phpunit/testcases/core/nav/bpCoreNewSubnavItem.php	(revision 10744)
+++ /trunk/tests/phpunit/testcases/core/nav/bpCoreNewSubnavItem.php	(revision 10745)
@@ -6,4 +6,7 @@
 class BP_Tests_Core_Nav_BpCoreNewSubnavItem extends BP_UnitTestCase {
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_user_subnav() {
 		$bp_options_nav = buddypress()->bp_options_nav;
@@ -17,9 +20,17 @@
 		$this->go_to( $user_domain );
 
+		bp_core_new_nav_item( array(
+			'name'            => 'Foo Parent',
+			'slug'            => 'foo-parent',
+			'link'            => trailingslashit( $user_domain . 'foo-parent' ),
+			'screen_function' => 'foo_screen_function',
+			'position'        => 10,
+		) );
+
 		bp_core_new_subnav_item( array(
 			'name'            => 'Foo',
 			'slug'            => 'foo',
-			'parent_url'      => trailingslashit( $user_domain . 'foo' ),
-			'parent_slug'     => 'foo',
+			'parent_url'      => trailingslashit( $user_domain . 'foo-parent' ),
+			'parent_slug'     => 'foo-parent',
 			'screen_function' => 'foo_screen_function',
 			'position'        => 10
@@ -28,5 +39,5 @@
 		$expected = array(
 			'name'              => 'Foo',
-			'link'              => trailingslashit( $user_domain . 'foo/foo' ),
+			'link'              => trailingslashit( $user_domain . 'foo-parent/foo' ),
 			'slug'              => 'foo',
 			'css_id'            => 'foo',
@@ -38,5 +49,7 @@
 		);
 
-		$this->assertSame( buddypress()->bp_options_nav['foo']['foo'], $expected );
+		foreach ( $expected as $k => $v ) {
+			$this->assertSame( $v, buddypress()->bp_options_nav['foo-parent']['foo'][ $k ] );
+		}
 
 		// Clean up
@@ -103,16 +116,26 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_link_provided() {
 		$bp_options_nav = buddypress()->bp_options_nav;
 
-		bp_core_new_subnav_item( array(
-			'name' => 'bar',
-			'slug' => 'bar',
-			'parent_slug' => 'foo',
-			'parent_url' => 'foo',
+		bp_core_new_nav_item( array(
+			'name' => 'Foo',
+			'slug' => 'foo',
 			'screen_function' => 'foo',
 			'link' => 'https://buddypress.org/',
 		) );
 
+		bp_core_new_subnav_item( array(
+			'name' => 'bar',
+			'slug' => 'bar',
+			'parent_slug' => 'foo',
+			'parent_url' => 'foo',
+			'screen_function' => 'foo',
+			'link' => 'https://buddypress.org/',
+		) );
+
 		$this->assertSame( 'https://buddypress.org/', buddypress()->bp_options_nav['foo']['bar']['link'] );
 
@@ -120,7 +143,17 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_link_built_from_parent_url_and_slug() {
 		$bp_options_nav = buddypress()->bp_options_nav;
 
+		bp_core_new_nav_item( array(
+			'name' => 'Foo',
+			'slug' => 'foo',
+			'screen_function' => 'foo',
+			'link' => 'https://buddypress.org/',
+		) );
+
 		bp_core_new_subnav_item( array(
 			'name' => 'bar',
@@ -136,14 +169,17 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_link_built_from_parent_url_and_slug_where_slug_is_default() {
 		$bp_nav = buddypress()->bp_nav;
 		$bp_options_nav = buddypress()->bp_options_nav;
 
-		// fake the parent
-		buddypress()->bp_nav = array(
-			'foo' => array(
-				'default_subnav_slug' => 'bar',
-			),
-		);
+		bp_core_new_nav_item( array(
+			'name' => 'Foo',
+			'slug' => 'foo',
+			'screen_function' => 'foo',
+			'default_subnav_slug' => 'bar',
+		) );
 
 		bp_core_new_subnav_item( array(
@@ -162,5 +198,15 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_should_trailingslash_link_when_link_is_autogenerated_using_slug() {
+		bp_core_new_nav_item( array(
+			'name' => 'Foo',
+			'slug' => 'foo',
+			'screen_function' => 'foo',
+			'link' => 'https://buddypress.org/',
+		) );
+
 		bp_core_new_subnav_item( array(
 			'name' => 'bar',
@@ -175,4 +221,7 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_should_trailingslash_link_when_link_is_autogenerated_not_using_slug() {
 		bp_core_new_nav_item( array(
@@ -188,9 +237,9 @@
 			'slug' => 'bar',
 			'parent_slug' => 'foo-parent',
-			'parent_url' => bp_get_root_domain() . 'foo-parent/',
+			'parent_url' => bp_get_root_domain() . '/foo-parent/',
 			'screen_function' => 'bar',
 		) );
 
-		$expected = bp_get_root_domain() . 'foo-parent/';
+		$expected = bp_get_root_domain() . '/foo-parent/';
 		$this->assertSame( $expected, buddypress()->bp_options_nav['foo-parent']['bar']['link'] );
 	}
@@ -198,8 +247,16 @@
 	/**
 	 * @ticket BP6353
+	 * @expectedIncorrectUsage bp_nav
 	 */
 	public function test_link_should_not_trailingslash_link_explicit_link() {
 		$link = 'http://example.com/foo/bar/blah/?action=edit&id=30';
 
+		bp_core_new_nav_item( array(
+			'name' => 'Foo',
+			'slug' => 'foo',
+			'screen_function' => 'foo',
+			'link' => 'http://example.com/foo/',
+		) );
+
 		bp_core_new_subnav_item( array(
 			'name' => 'bar',
@@ -215,4 +272,10 @@
 
 	public function test_should_return_false_if_site_admin_only_and_current_user_cannot_bp_moderate() {
+		bp_core_new_nav_item( array(
+			'name' => 'Foo',
+			'slug' => 'foo',
+			'screen_function' => 'foo',
+		) );
+
 		// Should already be set to a 0 user.
 		$this->assertFalse( bp_current_user_can( 'bp_moderate' ) );
@@ -229,5 +292,14 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_css_id_should_fall_back_on_slug() {
+		bp_core_new_nav_item( array(
+			'name' => 'Parent',
+			'slug' => 'parent',
+			'screen_function' => 'foo',
+		) );
+
 		$args = array(
 			'name' => 'Foo',
@@ -242,5 +314,14 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_css_id_should_be_respected() {
+		bp_core_new_nav_item( array(
+			'name' => 'Parent',
+			'slug' => 'parent',
+			'screen_function' => 'foo',
+		) );
+
 		$args = array(
 			'name' => 'Foo',
Index: /trunk/tests/phpunit/testcases/core/nav/bpCoreRemoveNavItem.php
===================================================================
--- /trunk/tests/phpunit/testcases/core/nav/bpCoreRemoveNavItem.php	(revision 10744)
+++ /trunk/tests/phpunit/testcases/core/nav/bpCoreRemoveNavItem.php	(revision 10745)
@@ -6,4 +6,7 @@
  */
 class BP_Tests_Core_Nav_BpCoreRemoveNavItem extends BP_UnitTestCase {
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_should_remove_subnav_items() {
 		$bp = buddypress();
@@ -38,4 +41,7 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_should_remove_nav_item() {
 		$bp = buddypress();
Index: /trunk/tests/phpunit/testcases/core/nav/bpCoreRemoveSubnavItem.php
===================================================================
--- /trunk/tests/phpunit/testcases/core/nav/bpCoreRemoveSubnavItem.php	(revision 10744)
+++ /trunk/tests/phpunit/testcases/core/nav/bpCoreRemoveSubnavItem.php	(revision 10745)
@@ -6,4 +6,7 @@
  */
 class BP_Tests_Core_Nav_BpCoreRemoveSubnavItem extends BP_UnitTestCase {
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_should_remove_subnav_item() {
 		$bp = buddypress();
@@ -36,4 +39,7 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	public function test_should_fail_on_incorrect_parent() {
 		$bp = buddypress();
@@ -65,33 +71,3 @@
 		$bp->bp_options_nav = $_bp_options_nav;
 	}
-
-	public function test_should_remove_parent_array_if_left_childless() {
-		$bp = buddypress();
-
-		$_bp_nav = $bp->bp_nav;
-		$_bp_options_nav = $bp->bp_options_nav;
-
-		bp_core_new_nav_item( array(
-			'name' => 'Foo',
-			'slug' => 'foo',
-			'screen_function' => 'foo',
-		) );
-
-		bp_core_new_subnav_item( array(
-			'name' => 'Bar',
-			'slug' => 'bar',
-			'parent_slug' => 'foo',
-			'parent_url' => 'foo',
-			'screen_function' => 'bar',
-		) );
-
-		$this->assertTrue( isset( $bp->bp_options_nav['foo']['bar'] ) );
-
-		bp_core_remove_subnav_item( 'foo', 'bar' );
-
-		$this->assertFalse( isset( $bp->bp_options_nav['foo'] ) );
-
-		$bp->bp_nav = $_bp_nav;
-		$bp->bp_options_nav = $_bp_options_nav;
-	}
 }
Index: /trunk/tests/phpunit/testcases/groups/class-bp-group-extension.php
===================================================================
--- /trunk/tests/phpunit/testcases/groups/class-bp-group-extension.php	(revision 10744)
+++ /trunk/tests/phpunit/testcases/groups/class-bp-group-extension.php	(revision 10745)
@@ -218,4 +218,5 @@
 	/**
 	 * @group enable_nav_item
+	 * @expectedIncorrectUsage bp_nav
 	 */
 	public function test_enable_nav_item_true() {
@@ -240,4 +241,5 @@
 	/**
 	 * @group enable_nav_item
+	 * @expectedIncorrectUsage bp_nav
 	 */
 	public function test_enable_nav_item_false() {
@@ -262,4 +264,5 @@
 	/**
 	 * @group visibility
+	 * @expectedIncorrectUsage bp_nav
 	 */
 	public function test_visibility_private() {
@@ -299,4 +302,5 @@
 	/**
 	 * @group visibility
+	 * @expectedIncorrectUsage bp_nav
 	 *
 	 * visibility=public + status=private results in adding the item to
Index: /trunk/tests/phpunit/testcases/routing/anonymous.php
===================================================================
--- /trunk/tests/phpunit/testcases/routing/anonymous.php	(revision 10744)
+++ /trunk/tests/phpunit/testcases/routing/anonymous.php	(revision 10745)
@@ -11,5 +11,6 @@
 	function test_nav_menu() {
 		$this->go_to( '/' );
-		$this->assertEmpty( buddypress()->bp_nav );
+		$nav = buddypress()->members->nav->get_item_nav();
+		$this->assertEmpty( $nav );
 	}
 }
Index: /trunk/tests/phpunit/testcases/routing/core.php
===================================================================
--- /trunk/tests/phpunit/testcases/routing/core.php	(revision 10744)
+++ /trunk/tests/phpunit/testcases/routing/core.php	(revision 10745)
@@ -23,4 +23,7 @@
 	}
 
+	/**
+	 * @expectedIncorrectUsage bp_nav
+	 */
 	function test_nav_menu() {
 		$this->go_to( '/' );
